PlayerCc::PlannerProxy Class Reference
Proxies

The `PlannerProxy` proxy provides an interface to a 2D motion planner. More...

`#include <playerc++.h>`

Inheritance diagram for PlayerCc::PlannerProxy:

## Public Member Functions

| PlannerProxy (PlayerClient *aPc, uint32_t aIndex=0)
| constructor
| ~PlannerProxy ()
| destructor
void | SetGoalPose (double aGx, double aGy, double aGa)
| Set the goal pose (gx, gy, ga)
void | RequestWaypoints ()
| Get the list of waypoints. More...
void | SetEnable (bool aEnable)
| Enable/disable the robot's motion. More...
uint32_t | GetPathValid () const
| Did the planner find a valid path?
uint32_t | GetPathDone () const
| Have we arrived at the goal?
double | GetPx () const
| Current pose (m) More...
double | GetPy () const
| Current pose (m) More...
double | GetPa () const
| Current pose (radians) More...
player_pose2d_t | GetPose () const
| Get the current pose.
double | GetGx () const
| Goal location (m) More...
double | GetGy () const
| Goal location (m) More...
double | GetGa () const
| Goal location (radians) More...
player_pose2d_t | GetGoal () const
| Get the goal.
double | GetWx () const
| Current waypoint location (m) More...
double | GetWy () const
| Current waypoint location (m) More...
double | GetWa () const
| Current waypoint location (rad) More...
player_pose2d_t | GetCurrentWaypoint () const
| Get the current waypoint.
double | GetIx (int i) const
| Grab a particular waypoint location (m) More...
double | GetIy (int i) const
| Grab a particular waypoint location (m) More...
double | GetIa (int i) const
| Grab a particular waypoint location (rad) More...
player_pose2d_t | GetWaypoint (uint32_t aIndex) const
| Get the waypoint.
int | GetCurrentWaypointId () const
| Current waypoint index (handy if you already have the list of waypoints). More...
uint32_t | GetWaypointCount () const
| Number of waypoints in the plan.
player_pose2d_t | operator[] (uint32_t aIndex) const
| Waypoint access operator This operator provides an alternate way of access the waypoint data. More...
Public Member Functions inherited from PlayerCc::ClientProxy
bool | IsValid () const
| Returns true if we have received any data from the device.
bool | IsFresh () const
| Fresh is set to true on each new read. More...
void | NotFresh ()
| This states that the data in a client is currently not Fresh.
std::string | GetDriverName () const
| Returns the driver name. More...
double | GetDataTime () const
| Returns the received timestamp [s].
double | GetElapsedTime () const
| Returns the received timestamp [s].
PlayerClient * | GetPlayerClient () const
| Returns a pointer to the Player Client.
uint32_t | GetIndex () const
| Returns device index.
uint32_t | GetInterface () const
| Returns device interface.
std::string | GetInterfaceStr () const
| Returns device interface.
void | SetReplaceRule (bool aReplace, int aType=-1, int aSubtype=-1)
| Set a replace rule for this proxy on the server. More...
int | HasCapability (uint32_t aType, uint32_t aSubtype)
| Request capabilities of device. More...
int | GetBoolProp (char *aProperty, bool *aValue)
| Request a boolean property.
int | SetBoolProp (char *aProperty, bool aValue)
| Set a boolean property.
int | GetIntProp (char *aProperty, int32_t *aValue)
| Request an integer property.
int | SetIntProp (char *aProperty, int32_t aValue)
| Set an integer property.
int | GetDblProp (char *aProperty, double *aValue)
| Request a double property.
int | SetDblProp (char *aProperty, double aValue)
| Set a double property.
int | GetStrProp (char *aProperty, char **aValue)
| Request a string property.
int | SetStrProp (char *aProperty, char *aValue)
| Set a string property.
template<typename T >
connection_t | ConnectReadSignal (T aSubscriber)
| Connect a signal to this proxy For more information check out Signals & multithreading.
void | DisconnectReadSignal (connection_t aSubscriber)
| Disconnect a signal to this proxy.

## Private Member Functions

void | Subscribe (uint32_t aIndex)
void | Unsubscribe ()

## Private Attributes

playerc_planner_t * | mDevice

## Additional Inherited Members

Public Types inherited from PlayerCc::ClientProxy
typedef int | connection_t
typedef boost::mutex::scoped_lock | scoped_lock_t
typedef int | read_signal_t
Protected Member Functions inherited from PlayerCc::ClientProxy
| ClientProxy (PlayerClient *aPc, uint32_t aIndex)
template<typename T >
T | GetVar (const T &aV) const
template<typename T >
void | GetVarByRef (const T aBegin, const T aEnd, T aDest) const
Protected Attributes inherited from PlayerCc::ClientProxy
PlayerClient * | mPc
playerc_client_t * | mClient
playerc_device_t * | mInfo
bool | mFresh

## Detailed Description

The `PlannerProxy` proxy provides an interface to a 2D motion planner.

## Member Function Documentation

int PlayerCc::PlannerProxy::GetCurrentWaypointId | ( |  | ) | const

inline

Current waypoint index (handy if you already have the list of waypoints).

May be negative if there's no plan, or if the plan is done

double PlayerCc::PlannerProxy::GetGa | ( |  | ) | const

inline

Goal location (radians)

Deprecated:
  use GetGoal() instead

double PlayerCc::PlannerProxy::GetGx | ( |  | ) | const

inline

Goal location (m)

Deprecated:
  use GetGoal() instead

double PlayerCc::PlannerProxy::GetGy | ( |  | ) | const

inline

Goal location (m)

Deprecated:
  use GetGoal() instead

double PlayerCc::PlannerProxy::GetIa | ( | int | i | ) | const

Grab a particular waypoint location (rad)

Deprecated:
  use GetWaypoint() instead

double PlayerCc::PlannerProxy::GetIx | ( | int | i | ) | const

Grab a particular waypoint location (m)

Deprecated:
  use GetWaypoint() instead

double PlayerCc::PlannerProxy::GetIy | ( | int | i | ) | const

Grab a particular waypoint location (m)

Deprecated:
  use GetWaypoint() instead

double PlayerCc::PlannerProxy::GetPa | ( |  | ) | const

inline

Current pose (radians)

Deprecated:
  use GetPose() instead

double PlayerCc::PlannerProxy::GetPx | ( |  | ) | const

inline

Current pose (m)

Deprecated:
  use GetPose() instead

double PlayerCc::PlannerProxy::GetPy | ( |  | ) | const

inline

Current pose (m)

Deprecated:
  use GetPose() instead

double PlayerCc::PlannerProxy::GetWa | ( |  | ) | const

inline

Current waypoint location (rad)

Deprecated:
  use GetCurWaypoint() instead

double PlayerCc::PlannerProxy::GetWx | ( |  | ) | const

inline

Current waypoint location (m)

Deprecated:
  use GetCurWaypoint() instead

double PlayerCc::PlannerProxy::GetWy | ( |  | ) | const

inline

Current waypoint location (m)

Deprecated:
  use GetCurWaypoint() instead

player_pose2d_t PlayerCc::PlannerProxy::operator[] | ( | uint32_t | aIndex | ) | const

inline

Waypoint access operator This operator provides an alternate way of access the waypoint data.

For example, given a `PlannerProxy` named `pp`, the following expressions are equivalent: `pp.GetWaypoint(0)` and `pp`[0].

void PlayerCc::PlannerProxy::RequestWaypoints | ( |  | ) |

Get the list of waypoints.

Writes the result into the proxy rather than returning it to the caller.

void PlayerCc::PlannerProxy::SetEnable | ( | bool | aEnable | ) |

Enable/disable the robot's motion.

Set state to true to enable, false to disable.

The documentation for this class was generated from the following file:

- playerc++.h

Last updated 12 September 2005 21:38:45